import { select, json, geoPath, geoTransverseMercator, zoom, event } from "d3";
import { feature } from "topojson";
const svg = select("svg");

const width = +svg.attr('width');
const height = +svg.attr('height');
//The geoMercator() function in d3.js is used 
//to draw The spherical Mercator projection.
const projection = d3.geoTransverseMercator()
  .center([4.5, -40.5])
	.rotate([60, 0])
  .scale((height * 65) / 33)
  .translate([(width / 2), (height /2)]);
// given a JSON geometry object, to generates an SVG path
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g')

g.append('path')
  .attr('class', 'sphere')
  .attr('d', pathGenerator({type: 'Sphere'}));

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform)
}));
//gisthub link to get Uruguay data
json('https://raw.githubusercontent.com/tonywr71/GeoJson-Data/master/australian-states.json')
  .then(data => {
    g.selectAll('#path')
      .data(data.features)
      .enter().append('path')
				.attr('class', 'country')
				.attr('d', pathGenerator)
  //Renders the path to a Canvas by appending path 
  //generated by pathgenerator to svg
  
  });